package cz.upol.logs.func;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;


public class Fibs {
	
	private static final Logger logger = Logger.getLogger(Fibs.class.getName());
	
	public static List<Integer> fibs(int... values) {
		logger.info("Zacatek vypoctu");
		List<Integer> results = new ArrayList<>(values.length);
		for (int i : values) {
			try {
				if (i > 32) logger.warning("Bude to chvili trvat");
				results.add(fib(i));
			} catch (Exception e) {
				logger.log(Level.SEVERE, "Chyba", e);
			}
		}
		logger.info("Konec vypoctu");
		return results;
	}
	
	private static int fib(int n) {
		if (n < 0) throw new IllegalArgumentException("Nedefinovana hodnota pro: " + n);
		if (n <= 1) return n;
		return fib(n - 1) + fib(n - 2);
	}

}
